package pendo.io.pendo_sdk;
import sdk.pendo.io.sdk.flutter.*;
import java.util.Map;
import android.app.Activity;
import android.graphics.Bitmap;
import android.util.Log;
import android.view.View;
import android.view.Window;

import androidx.annotation.NonNull;

import java.io.ByteArrayOutputStream;
import android.util.Base64;

import io.flutter.embedding.engine.renderer.FlutterRenderer;
import io.flutter.view.FlutterView;

public class FlutterPluginBridge implements sdk.pendo.io.sdk.flutter.IFlutterBridge {
    private IFlutterEventsCallback flutterEventsCallback = null;
    private Object mRenderer;
    private Activity mActivity;

    public FlutterPluginBridge(Activity activity, Object render) {
        mActivity = activity;
        mRenderer = render;
    }
    @Override
    public void registerForEvents(@NonNull IFlutterEventsCallback flutterScreenEventCallback) {
        flutterEventsCallback = flutterScreenEventCallback;
    }

    public void newScreenIdentified(String screenName, Map<String, Object> screenInfo) {
        if (flutterEventsCallback != null) {
            flutterEventsCallback.newScreenIdentified(screenName, screenInfo);
        }
    }

    @Override
    public String generateBitmap() {
        try {
            Bitmap bitmap = null;
            if (this.mRenderer.getClass() == FlutterView.class) {
                bitmap = ((FlutterView) this.mRenderer).getBitmap();
            } else if (this.mRenderer.getClass() == FlutterRenderer.class) {
                bitmap = ((FlutterRenderer) this.mRenderer).getBitmap();
            }
            return convertBitmapToBase64(bitmap);
        } catch (Exception ex) {
            Log.e("Pendo", "Failed to generate bitmap " + ex);
        }
        return null;
    }

    private String convertBitmapToBase64(Bitmap bitmap) {
        if(bitmap == null) {
            return null;
        }
        ByteArrayOutputStream byteArrayOutputStream = new ByteArrayOutputStream();
        bitmap.compress(Bitmap.CompressFormat.JPEG, 10, byteArrayOutputStream);
        byte[] byteArray = byteArrayOutputStream.toByteArray();
        return Base64.encodeToString(byteArray, Base64.DEFAULT);
    }
}