/*
 *  * Copyright © 2019 Pendo.io. All rights reserved.
*/
import 'dart:async';

typedef Callback = void Function();
const int _kDefaultDebouncerTime = 200;

class PendoDebouncer {
  Timer? _timer;
  final Duration duration;
  PendoDebouncer({Duration? duration}): this.duration = duration ?? Duration(milliseconds: _kDefaultDebouncerTime);

  void execute(Callback callback) {
    if (_timer != null) {
      _timer?.cancel();
      _timer = null;
    }
    _timer = Timer(duration, callback);
  }
}
