
extension StringMatching on String {

  String extractName() {
    //match anything in the single quotes
    final regex = RegExp(r"'([^']+)'");
    final matches = regex.allMatches(this);

    if (matches.isEmpty) {
      return '';
    }

    final unitedMatch = matches.map((match) => match.group(1) ?? '').join();
    return unitedMatch;
  }

  String extractReturnTypeFromBuilderDescription() {
    //The format we get  "xxx => match"
    final regex  = RegExp(r'=>\s*(.*)');
    final match = regex.firstMatch(this);
    if (match != null && match.groupCount >= 1) {
      return match.group(1)!;
    }
    return '';
  }
}
